

#include <iostream>
using namespace std;

//part a i recursive
int recursiveA(int );
int recursiveX(int );
int recursiveY(int );
int iterativeA(int );

int recursiveA(int n)
{
	if (n>=1) {
		int x=recursiveX(n);
		int y=recursiveY(n);
		return x+y;
	}
	else exit(0);
}

int recursiveX(int n)
{
	if (n == 1 || n ==2 ) return 1;
	else 
		if(n%2 ==0)  
		{ 
			return 2*recursiveX(n/2)+n;

		}
		else  return recursiveY(n-1)+2*n;
}

int recursiveY(int n)
{
	if (n == 1 || n ==2 ) return 2;
	else 
		if(n%2 ==0)  
		{ 
			return 3*recursiveY(n/3)+1;

		}
		else  return recursiveX(n-2)+n;
}

int iterativeA(int n) {
	int *X = new int [n];
	int *Y = new int [n];
	for (int i=1 ; i<=n ; i++) {
		if (i==1 || i==2) {
			X[i] = 1;
			Y[i] = 2;
		}
		else if (i%2 ==0) {
			X[i] = 2*X[i/2]+i;
			Y[i] = 3*Y[i/3]+1;
		}
		else {
			X[i] = Y[i-1]+2*i;
			Y[i] = X[i-2]+i;
		}	
	}
	return X[n]+Y[n];
}




void main() {
	for(int i=1;i<=20;i++) 	cout<< recursiveA(i)<<" ";
	cout<<endl<<endl;
	for(i=1;i<=20;i++) 	cout<< iterativeA(i)<<" ";
	cout<<endl;
}