

#include <iostream>
using namespace std;

void ternaryMergeSort(int [],int ,int );
void Merge(int  [], int , int ,int , int );
void printArray(int *,int ,  int );
void merge15(const int [],int ,const int [], int , int [] );


void main()
{ 

	  int A[] = {5,2,4,1}; 
 
      ternaryMergeSort(A,0,3);

	  for (int i=0;i<4;i++)  cout<<A[i]<<" "; 
} 

void ternaryMergeSort(int A[],int start,int end)
{
   if(start<end)  {
         int q = (start+end)/3;
		 int s = 2*q;
         ternaryMergeSort(A,start,q);
         ternaryMergeSort(A,q+1,s);
		 ternaryMergeSort(A,s+1,end);
		 Merge(A,start,q,s,end);
   } 
 }


void Merge(int  A[], int p, int q, int s, int r)
{
	
   int * B = new int[q-p+1];
   int * C = new int[s-q];
   int * D = new int[s-p+1];
   int * E = new int[r-s+1];
   int * F = new int[r-p+1];
   
   for(int i=p;i<=q;i++) B[i-p]=A[i];      
   for(i=q+1;i<=s;i++) C[i-q-1]=A[i];       
   
   merge15(B,q-p+1,C,s-q,D);            

   
   for(i=p;i<=s;i++) A[i]=D[i-p];           
   
   
   for(i=s+1;i<=r;i++) E[i-s-1]=A[i];       

	merge15(D,s-p+1,E,r-s,F);

	for(i=p;i<=r;i++) A[i]=F[i-p];

   delete [] B; 
   delete [] C; 
   delete [] D;
   delete [] E; 
   delete [] F;
   
}

void printArray(int *A,int p,int r)
{  
	for(int i=p;i<=r;i++)  
         cout<<A[i]<<" "; 
	cout<<endl;
        
} 


void merge15(const int L[],int m,const int R[], int n, int C[] ) 

{
	
   int i =0, j = 0; 
   for(int k = 0;k<m+n;k++) 
   {
      if (i< m &&  j < n) 
          if (L[i]<R[j]) 
               { C[k] = L[i];  i++; }  
          else  
              {  C[k] = R[j];   j++; }
      else if  (i==m) {C[k] = R[j]; j = j+1;} 
      else if  (j==n) {C[k] = L[i];  i = i+1;} 
  }
}